
var concordance = scala.collection.immutable.TreeMap[String, List[Int]]()

var lineNumber = 0

val F = scala.io.Source.fromFile(args(0))

for (line <- F.getLines()) {
  lineNumber += 1
  println(lineNumber + ":\t" + line);
  val words = line.split("[ ,:;.?!-]+") map (_.toUpperCase)
  for (word <- words) {
    val lns = concordance.getOrElse(word, Nil)
    if (lns == Nil || lns.head != lineNumber)
      concordance += (word -> (lineNumber :: lns))
  }
}

for ((word, lns) <- concordance)
  printf("%20s: %s\n", word, lns.reverse.mkString(","))

println("lines: " + lineNumber)
println("distinct words: " + concordance.size)
